Available in🇮🇳 India
Use Razorpay Turbo UPI to make UPI payments faster. Follow these steps to integrate with Razorpay Turbo UPI Headless SDK.
Prerequisites
Prerequisites
-
Contact our integrations team to get your mobile number, app, and GitHub account whitelisted to get access to the
https://github.com/upi-turbo/ios-sample-app- sample app repository. In this repository, you will find the framework files (libraries for Turbo) and the sample app source code to help you with the integration. Use branchcustom_ui/turboto access the sample app and frameworks for Turbo UPI. The sample app workspace is divided into Prod and UAT environment targets with separate pod dependencies. - Integrate with Razorpay iOS Custom SDK.
-
Add the below line of code to your
Podfileto install Turbo pods:
- Import the Turbo plugin as given below:
1. Integration Steps
Follow these steps:1.1 Initialise the Razorpay Checkout
Initialise the SDK and set up the Checkout instance (Razorpay) to handle payment outcomes like success and errors by listening to delegate methods.1.2 Create a Session Token
To enhance security, you must create a session token via a server-to-server (S2S) call between your backend and Razorpay’s backend. This session token ensures secure communication between the Turbo SDK and Razorpay’s systems.How to Create a Session Token
- Trigger the S2S API from your Backend. Use the following API to generate a session token:
Request Parameters
Request Parameters
customer_reference mandatory
: string A unique identifier for the customer provided by the business. The recommended value is mobile number. For example, 9000090000.Response Parameters
Response Parameters
token
: string A session token to be used in subsequent session-protected APIs.expire_at
: long Expiry time (in seconds) for the session token, used to optimise session handling and reduce unnecessary reinitialisations.error
: object The request failure due to business or technical failure.- Pass the Generated Token to Turbo SDK. Use the session token in the initialisation step, ensuring that it is refreshed upon expiry.
1.3 Initialise Turbo SDK
After generating the session token, initialise the Turbo SDK with the session delegate. Use the initialize(…) method to configure the session.Swift
Create/Retry Session Token Mechanism
Using Delegate PatternTo ensure a smooth experience during token expiry, the Turbo SDK provides the
TurboSessionDelegate interface with a fetchToken method. This method dynamically fetches and updates the session token without reinitialising the session.
Initialise the TurboSessionDelegate object anonymously and pass it through the initialize method. The SDK will call fetchToken as needed and use the provided callback to handle the updated token. This allows you to seamlessly refresh the session by retrieving a new token via a server-to-server (S2S) call.
Below is an example of creating an instance of the TurboSessionDelegate interface using an anonymous object expression:
Kotlin
1.4 Handle UPI Account Linking and Payment Flow
After initialising the Turbo SDK, proceed to securely link UPI accounts and complete the payment flow- You need to link the customer’s UPI account with your app. Use the code samples given below to fetch the UPI account.
- Get the customer’s linked UpiAccount list using the below code. This function can be called from anywhere in the application, providing multiple entry points for customers to link their UPI account with your app.
Request Parameters
Request Parameters
mobile_num
: string The customer’s mobile number.Delegate
: object The Delegate to be sent is of type UpiTurboResultDelegate.- If your customer has already linked the UPI account, use the following code to fetch it. If there are no linked UPI accounts, an empty list is returned.
Response Parameters
Response Parameters
onSuccess
: string This function is triggered if the list is fetched successfully. accList can be empty to indicate that no accounts have been linked yet.onError
: string This function is triggered in case an error is thrown during the retrieval process, either by the Razorpay SDK or the Bank SDK.-
If the customer has not linked any UPI account, they can link UPI accounts using the following method:
- Link one UPI account at a time:
Use the following code to link the newly created UPI account with your app. This function can be called from anywhere in the application, providing multiple entry points for customers to link their UPI account with your app.
- Link one UPI account at a time:
action
: The current state of customer registration with which you can call further functions. All values for this variable are exposed as an enum for ease of integration. Know more about the action parameters.
Request Parameters
Request Parameters
mobileNumber mandatory
: string Customer’s mobile number needed to initialise the SDKs.linkActionDelegate
: UpiTurboLinkAccountDelegate Used as a callback to send a response or failure to you. Given below are the functions:action.code: This function denotes that the user registration is incomplete and additional action is required.action.data: This function denotes that the user has registered UpiAccounts on the device. It returns a list of UpiAccount objects, which can then be used to show the details on UI.action.error: Returns an error object with a description and message relating to a failure in either one of the registration steps or in retrieving the UpiAccount list.
- The Reward feature allows you to allocate rewards to users without specific criteria. To avail rewards, you need to configure them from the Dashboard. You can seamlessly integrate this function into your application, providing multiple entry points for users to check their rewards eligibility before completing a payment.
Request Parameters
Request Parameters
mobileNumber mandatory
: string The customer’s mobile number.action mandatory
: RewardAction This parameter specifies the action to check reward eligibility. Possible values:onboarding: To check reward eligibility for Onboarding.payment: To check reward eligibility for Payment.
amount optional
: string The transaction amount expressed in the currency subunits.rewardsDelegate mandatory
: delegate This parameter allows you to receive callbacks regarding reward eligibility.- To process the payments, call the
authorizemethod of custom checkout with the provided payload. Upon receiving thePaymentDataresponse, you will also receiverewardStatusalong with the payment response. Please note that therewardStatuskey will be present in the response only if your eligible for a reward.
Request Parameters
Request Parameters
amount mandatory
: integer The transaction amount expressed in the currency subunit. For example, for an actual amount of ₹299.35, the value of this field should be 29935.currency mandatory
: string The currency in which the transaction should be made.email mandatory
: string Email address of the customer.contact mandatory
: string Customer’s phone number.order_id optional
: string Order id generated via the Orders API.method mandatory
: string The payment method used by the customer on Checkout. In this case, it is upi (default).upi mandatory
: array Details of the UPI payment.flow mandatory
: string Type of the UPI method. In this case, it is in_app.Non-Transactional Flows
You can directly interact with the exposed methods of the Turbo Framework to perform the non-transactional flows listed below.Fetch Balance
Fetch Balance
Fetch the customer’s account balance. Call
getBalance() on the bank account object received from upiAccount.Change UPI PIN
Change UPI PIN
Provide the customer the ability to change their UPI PIN. Call
changeUpiPin() on the bank account object received from upiAccount.Reset UPI PIN
Reset UPI PIN
Let your customers reset their UPI PIN. Call
resetUpiPin() on the bank account object received from getLinkedUpiAccounts().Delink UpiAccount
Delink UpiAccount
Let your customers delink their UpiAccounts.
Additional Features
To get the device binding status, please use the variablerazorpay.upiTurbo.deviceBindingDone of type boolean. It indicates whether the device binding, which is a prerequisite for adding UPI accounts, is done with the user’s mobile number.
Action Parameter Values
Action Parameter Values
Following are the constants that are passed in
action.code parameter in onResponse.Models Exposed from the SDKs
The SDKs given below provide access to exposed models for seamless integration.UpiBankAccount
UpiBankAccount
UpiAccountBalance
UpiAccountBalance
UpiAccount
UpiAccount
UpiCard
UpiCard
UpiBank
UpiBank
AllBanks
AllBanks
TurboError
TurboError
UpiBankAccountState
UpiBankAccountState
Consent
Consent
ConsentType enum
ConsentType enum
PrefetchBank
PrefetchBank
CustomerReward
CustomerReward
Reward
Reward
PaymentData
PaymentData
RewardAction
RewardAction
2. Test Integration
We recommend the following:- Complete the integration on UAT before using the prod builds.
- Perform the UAT using the Razorpay-provided API keys.
3. Go-live Checklist
Complete these steps to take your integration live:- You should get your app id whitelisted by Razorpay to test on prod.
Handy TipsContact our integrations team to get your mobile number and app whitelisted.
-
Import the prod library from the GitHub repository →
https://github.com/upi-turbo/ios-sample-appcustom_ui/turbobranch. - Switch to Prod environment and podfile.
- Replace the UAT credential with the Razorpay live keys for prod testing.
For iOS users, outgoing device binding SMS is editable by default. To ensure these SMS messages are non-editable, you must complete the following steps:
Requesting UPI Device Validation Entitlement
Submit a Request on the Apple Developer Portal
Submit a Request on the Apple Developer Portal
- Log in to the Apple Developer Portal.
- Fill out the necessary details to request permission for the
setUPIVerificationCodeSendCompletionAPI, which allows secure, non-editable content for device registration SMS. - Await approval from Apple.
Submit Details to NPCI
Submit Details to NPCI
Once Apple approves the entitlement, share the request details with NPCI for their approval. Use the format given below for submitting the details:
- Name of the App:
- Functionality (UPI or CBDC App): UPI
- App ID:
- Team ID:
- Request ID:
- Bundle ID:
Follow the Guidelines for Implementation
Follow the Guidelines for Implementation
- Ensure your app supports iOS 17 and above.
- Use the
setUPIVerificationCodeSendCompletionAPI to comply with NPCI requirements.